/* Copyright (C) Bill Buckels 2008 */

disk(cx,cy,r,color,mode)
int cx,cy,r,color,mode;
{

    int xc, yc;          /* xcenter, ycenter */
    int x,y;            /*current point around 1/8 disk*/
    int rem;           /*remainder value*/

    cx -= r;   /* draw from top left */
    cy -= r;

    xc = r;        /* offset center by aspect */
    yc = r;

    y=0;
    x=r;            /*initial point is on axis*/
    rem=r/2;        /*remainder=1/2 for roundoff*/
    while (x>=y)    /*loop for 1/8 of a circle*/
    {
        /*fill in top half of circle*/
        drawline(xc-x+cx,yc+y+cy,xc+x+cx,yc+y+cy,color, mode);
        /*and bottom half*/
        drawline(xc-x+cx,yc-y+cy,xc+x+cx,yc-y+cy,color,mode);
        y += 1;                   /*always increment y*/
        rem=rem-y;               /*subtract from remainder*/
        if (rem<0)              /*if it's time,*/
        {
            x=x-1;      /*then decrement x*/
            rem=rem+x;   /*and bump remainder back up*/
        }
    }
    while(x>0)      /*loop for the top 1/8th of circle*/
    {
        x=x-1;          /*now you always move in x direction*/
        rem=rem-x;     /*and subtract x from the remainder*/
        if (rem<0)    /*when remainder underflows,*/
        {

            /*fill in the top side,*/
            drawline(xc-x+cx, yc+y+cy,xc+x+cx,yc+y+cy,color,mode);
            /*and the bottom*/
            drawline(xc-x+cx,yc-y+cy,xc+x+cx,yc-y+cy,color,mode);
            y=y+1;
            rem=rem+y;                /*bump the remainder back up*/
        }
    }
    return;
}
