/* (C) Copyright Bill Buckels 2008 */

/* action verbs for putimage */
/* expand as required */



#define PUT 0
#define GET 1
#define P_AND   2
#define P_STIX  3
#define P_BLACK 4
#define P_BLUE  5
#define P_RED   6
#define P_WHITE 7

#include <poke.h>


/* handles screen manipulation of image fragments */
/* both gets and puts */
putimage(fragbuf,rows,cols,rorg,corg,action)
char *fragbuf;
int rows,cols,rorg,corg,action;
{
   int col=0;
   char *ptr,*ptr2;
   int temp;
   int rmax=rorg+rows;
   char tempbyte=0;


   switch(action)
   {
	   case P_BLUE:  tempbyte= 0x55; break;
	   case P_RED:   tempbyte= 0xaa; break;
	   case P_WHITE: tempbyte= 0xff; break;
	   case P_BLACK:
	   default:      tempbyte= 0; break;
   }

   ptr = (char *)&fragbuf[0];

   cols = cols * 8; /* cols in columns - 8 byte blocks */

   while(rorg<rmax)
   {
     temp=rbase(rorg) + cbase(corg);
     ptr2 = (char *) &bmp[temp];

     /* expand action verbs as required */
     switch(action)
     {                /* if the image byte is black don't erase the */
                      /* background                                 */
        case P_AND  : for(col=0;col<cols;col++)
                      {
                       *ptr2|=*ptr;
                       *ptr2++;
                       *ptr++;
                       }
                       break;
        case P_STIX :
                      for(col=0;col<cols;col++)
                      {
                        tempbyte=*ptr++;
                        if(tempbyte==0)*ptr2++; /* black is transparent */
                        else *ptr2++=tempbyte;
                        }
                      break;

                   /* clear an area the size of the image fragment */
                   /* to black, blue, red, or white */
        case P_BLACK:
        case P_BLUE:
        case P_RED:
        case P_WHITE:
                     for(col=0;col<cols;col++)*ptr2++=tempbyte;
                     break;


                  /* read each raster into the buffer */
        case GET: blockmv(&fragbuf[col],&bmp[temp],cols);
                  col+=cols;
                  break;
        case PUT: /* read each raster to the screen */
        default :
                  blockmv(&bmp[temp],&fragbuf[col],cols);
                  col+=cols;
                  break;
     }
     rorg++;
     }
}


