/*	Copyright (c) 1982 by Manx Software Systems	*/
/*	Copyright (c) 1982 by Jim Goodnow II		*/

/*
	cmp - compare two files and tell when different.

	cmp [-l] file1 file2
*/

main(argc, argv)
int argc;
char **argv;
{
	register int f1, f2;
	register int i, j, n, tot;
	register char *c1 = 0, *c2 = 0, *cn;
	register int all = 0;
	char b1[256], b2[256];

	tot = 0;
	if (argc < 2) {
		printf("usage: cmp [-l] file1 file2\n");
		exit();
	}
	while (--argc) {
		switch ((*++argv)[0]) {
		case '-':
			switch((*argv)[1]) {
			case 'l':
				all = 1;
				break;
			default:
				printf("Bad option - %s\n", *argv);
				exit();
			}
			break;
		default:
			if (c1 == 0)
				c1 = *argv;
			else if (c2 == 0)
				c2 = *argv;
			else {
				printf("Too many file names.\n");
				exit();
			}
		}
	}
	if (c2 == 0) {
		printf("Too few file names.\n");
		exit();
	}

	if ((f1 = open(c1, 0)) < 0) {
		printf("cmp:couldn't open file '%s'\n", c1);
		exit();
	}
	if ((f2 = open(c2, 0)) < 0) {
		printf("cmp:couldn't open file '%s'\n", c2);
		exit();
	}
	for (;;) {
		i = read(f1, b1, 256);
		j = read(f2, b2, 256);
		if (i < j)
			n = i;
		else
			n = j;
		if (i == 0 && j == 0)
			exit();
		for (c1=b1,c2=b2,cn=b1+n;c1<cn;++c1,++c2) {
			if (*c1 != *c2) {
				if (!all) {
					printf("Files differ character %d\n", tot);
					exit();
				}
				printf("%5d %5x: %02x %02x\n", tot, tot, *c1&0xff, *c2&0xff);
			}
			++tot;
		}
		if (i != j) {
			printf("Files different in length character %d\n", tot);
			exit();
		}
	}
}

