/* time.h (C) Copyright Bill Buckels 2008 */

#ifdef CMAIN

/* snail cursor */
int srows = 5;
int scols = 9;
/* you must define your own save buffer for the screen behind
   the snail. you will need 360 bytes. This is to conserve memory
   and to not crash BASIC.

char _sback[360];
char *sback = (char *)&_sback[0];

*/
char *sleft = (char *)(7168+2);
char *sright = (char *)(7168+364);

/* note cursor */
/*

int nrows = 3;
int ncols = 2;

*/
char *snote  = (char *)(7168+726);
char *snback = (char *)(7168+774); /* save buffer for screen  */
int sndflag = 1;

/* colors for this program */
/* common palette shared between all screens */
int tvram = 234;
int tcram = 1;

int tbk = 0;
int tc1 = 14;
int tc2 = 10;
int tc3 = 1;


/* a memory saving table for sine cosine */
/* we don't want to haul around an entire math library for */
/* the sake of 184 bytes of data and a parser function     */

/* the divisor is 32767 (a signed int)   */

int sine_cosine[46][2]={
0,    32767,/* 0 degree offset*/
571,  32762,/* 1 degree offset*/
1143, 32747,/* 2 degree offset*/
1714, 32722,/* 3 degree offset*/
2285, 32687,/* 4 degree offset*/
2855, 32642,/* 5 degree offset*/
3425, 32587,/* 6 degree offset*/
3993, 32522,/* 7 degree offset*/
4560, 32448,/* 8 degree offset*/
5125, 32363,/* 9 degree offset*/
5689, 32269,/* 10 degree offset*/
6252, 32164,/* 11 degree offset*/
6812, 32050,/* 12 degree offset*/
7370, 31927,/* 13 degree offset*/
7927, 31793,/* 14 degree offset*/
8480, 31650,/* 15 degree offset*/
9031, 31497,/* 16 degree offset*/
9580, 31335,/* 17 degree offset*/
10125,31163,/* 18 degree offset*/
10667,30981,/* 19 degree offset*/
11206,30790,/* 20 degree offset*/
11742,30590,/* 21 degree offset*/
12274,30381,/* 22 degree offset*/
12803,30162,/* 23 degree offset*/
13327,29934,/* 24 degree offset*/
13847,29696,/* 25 degree offset*/
14364,29450,/* 26 degree offset*/
14875,29195,/* 27 degree offset*/
15383,28931,/* 28 degree offset*/
15885,28658,/* 29 degree offset*/
16383,28377,/* 30 degree offset*/
16876,28086,/* 31 degree offset*/
17363,27787,/* 32 degree offset*/
17846,27480,/* 33 degree offset*/
18323,27165,/* 34 degree offset*/
18794,26841,/* 35 degree offset*/
19259,26509,/* 36 degree offset*/
19719,26168,/* 37 degree offset*/
20173,25820,/* 38 degree offset*/
20620,25464,/* 39 degree offset*/
21062,25100,/* 40 degree offset*/
21497,24729,/* 41 degree offset*/
21925,24350,/* 42 degree offset*/
22347,23964,/* 43 degree offset*/
22761,23570,/* 44 degree offset*/
23169,23169};/*45 degree offset*/

/* values for game play */
int randseed = 0;
int randhrs[5];
int randmins[5];
int hrslimit=12;
int multi = 3;


char hrseed[50]=
    {
      /* first group for 1-12 hours */
      2,  11, 10, 8,  6,
      1,  7,  9,  5, 10,
      3,  12, 1,  4,  6,
      8,  3,  5,  7,  9,
      6,  4, 12,  8,  1,

      /* second group for 13-24 hours mixed with 1-12 hours */
      14,  11, 22,  5,   20,
      1,   19,  9,  17,  10,
      3,   24,  1,  16,  6,
      8,   13, 15,  7,   23,
      16,  4,  12,  8,   21};


/* a variety of minute values... */
int minseed[25]={
      5,  0,  10, 55, 15,
      45, 20, 35, 30, 25,
      15, 35, 10, 40, 5,
      45, 0,  50, 55, 10,
      20, 35, 40, 15, 55};


#else

/* colors for this program */
/* common palette shared between all screens */
extern int tvram;
extern int tcram;

extern int tbk;
extern int tc1;
extern int tc2;
extern int tc3;

/* snail cursor */
extern int srows;
extern int scols;
/* extern char *sback;
   save buffer for screen of 360 bytes required in each overlay
   that uses the cursor. no room in main module  */
extern char *sleft;
extern char *sright;

/* note cursor */
extern char *snote;
extern char *snback;
extern int sndflag;

/* game play */
extern int multi;
extern int hrslimit;        /* set to 12 for M0 or 24 for M1 and M2 */
extern int randhrs[5];
extern int randmins[5];


#endif