/* time.c (C) Copyright Bill Buckels 2008 */

/* this program is an expert level AztecC64 program */
/* it uses overlays and is just generally advanced */
/* if you haven't worked your way through the samples
   and other projects you may need to refer to those
   to really understand what is going-on here.

   then again, you may not. */



#define CMAIN 1

#include <poke.h>
#include <colors.h>
#include <math.h>
#include <time.h>
#include <sid.h>

main()
{
	int c=0;

    scr_clear();

    /* background color, bordercolor */
    scr_back(tbk,C64_BLUE);

	/* set multicolor mode 160 x 200 and display the logo */
	/* this program uses a matched palette */

	ovloader("CINIT",2,0);
    gclr(-1,tvram,tcram); /* keep this palette for the duration of the program */

    /* clear all keypresses */
    while (kbhit()); /* wait for key release */
    kbflush();

    /* start program by calling the menu */
    for (;;)
    {
       multi = 3;
       c = ovloader("MAINMENU",c);

       if (c == 3)break;


       switch(c) {
		   case 0: ovloader("T640",0); break;
		   case 1: ovloader("T641",0); break;
		   case 2: ovloader("T642",0); break;

	   }
       gclr(-1,tvram,tcram); /* reset default palette */

    }

    /* clean-up and exit */

    /* clear last palette and bitmap */
    gclr(0,0,0);
    ovloader("CINIT",0,2);
	scr_clear();

    /* clear all keypressess */
    while (kbhit());
    kbflush();
    /* stuff something in the keyboard to make Aztec C happy */
    kbuf[0] = 'X';
    kbuflen[0]=1;
	getchar();
	scr_clear(); /* clear screen to erase the X */

	exit(0);
}



libmain()
{
    /* dummy calls */
	/* library functions that must be saved in main overlay */
	/* add as required and careful about library functions
	   that use other library functions.

	   you will need to learn to balance your overlays for
	   larger applications. put the common calls in
	   the main application, and put the once-used or
	   special calls in their own overlays.

	   this speaks to the architecture of any overlay
	   framework in any environment whether it is on the
	   apple ][, C64, or old MS-DOS when memory was scarce.

	   an exhaustive topic. 'nuff said.

	*/

	/* see note above. this code is never executed */
	getpixel(0,0,2);
	putimage(snote,3,2,22,38,2);
	toupper(getch());
	box(0, 0, 159, 199, 3, 2);
	palset(vram,0,0,0,0,0,0);
	decode_scr(bmp,bmp,0);
}

/* about 1/3 of a second */
happy()
{
	if (sndflag  == 1) playnote(72,333,V_XYL,V_XYL,V_XYL);

}

/* about 1/3 of a second */
sappy()
{

	if (sndflag  == 1) playnote(12,333,0,0,0);

}

/* randomize 5 sets of hours and 5 sets of minutes  */
/* return the selected answer from the group        */
/* we must make certain that there is no repetition */
/* in groups of 5 hours.                            */

/* jiffy clock */
int *jiffy = (int *)160;

randval()
{
    int i,temp,temp2, j;

   /* there are either 25 or 50 hours choices               */
   /* if we pick them sequentially there will be no repeats */
   /* they have been shuffled fairly well.                  */


   j = jiffy[0];
   if (j < 0)j = (j * -1);

   randseed = (j % 25);

   if(hrslimit==12) {
	   temp=24;
   }
   else {
	   randseed = randseed + 25;
       temp=49;
    }

   temp2=temp-24;

    for(i=0;i<5;i++)
    {
      randseed = (randseed + 1);
      if(randseed>temp)randseed=temp2;
      randhrs[i]=(int)hrseed[randseed];
      }


    /* get one of the 25 minute choices */
    randseed = (randseed + randhrs[0]);
    temp=24;

    for(i=0;i<5;i++)
    {
      randseed = (randseed + 1);
      if(randseed>temp)randseed=0;
      randmins[i]=(int)minseed[randseed];
      }

    /* return an answer within the range of questions */
    return randhrs[0]%multi;
}


circlepoints(x,y,baselength,fdegrees)
int *x, *y;
int baselength;
float fdegrees;
{
    float xtemp;
    float ytemp;
    int degrees = (int )fdegrees;
    float aspect_h, aspect_v;

    aspect_h = (float)1.16;
    aspect_v = (float)1;

	/*  starting at 12 O'clock    */
	/* use a switch for the break */
	switch(degrees)
	{


    	default:

		/* within range */
		if(degrees<0 || degrees >359)degrees=0;

		/*  0-45  sin */
		if(degrees < 45)
		{
		xtemp = (float) sine_cosine[degrees][0];
		ytemp = (float) sine_cosine[degrees][1];
		ytemp = ytemp * -1;
		break;
		}

		/* 45-90  cos */
		if(degrees < 90)
		{
		xtemp = (float) sine_cosine[90-degrees][1];
		ytemp = (float) sine_cosine[90-degrees][0];
		ytemp = ytemp * -1;
		break;
		}

	   /* 90 - 135 */
	   if(degrees < 135)
	   {
		xtemp = (float) sine_cosine[degrees-90][1];
		ytemp = (float) sine_cosine[degrees-90][0];
		break;
		}

		/* 135 - 180 */
	   if(degrees< 180)
	   {
		xtemp = (float) sine_cosine[180-degrees][0];
		ytemp = (float) sine_cosine[180-degrees][1];
		break;
		}

	   /* 180 - 225 */
	   if(degrees< 225)
	   {
		xtemp = (float) sine_cosine[degrees-180][0];
		xtemp = xtemp * -1;
		ytemp = (float) sine_cosine[degrees-180][1];
		break;
		}

	   /* 225 - 270 */
	   if(degrees< 270)
	   {
		xtemp = (float) sine_cosine[270-degrees][1];
		xtemp = xtemp * -1;
		ytemp = (float) sine_cosine[270-degrees][0];
		break;
		}

	   /*  270 - 315 */
	   if(degrees< 315)
	   {
		xtemp = (float) sine_cosine[degrees-270][1];
		xtemp = xtemp * -1;
		ytemp = (float) sine_cosine[degrees-270][0];
		ytemp = ytemp * -1;
		break;
		}

		/* 315 - 360 */
		xtemp = (float) sine_cosine[360-degrees][0];
		xtemp = xtemp * -1;
		ytemp = (float) sine_cosine[360-degrees][1];
		ytemp = ytemp * -1;
    }

    ytemp = ytemp/32767;
    xtemp = xtemp/32767;

    xtemp *= (aspect_h*baselength);
    ytemp *= (aspect_v*baselength);

    *x += (int )xtemp;
    *y += (int )ytemp;

}