/*	Copyright (c) 1982 by Manx Software Systems	*/
/*	Copyright (c) 1982 by Jim Goodnow II		*/

/*
	od - dump a file in hex and ascii

	od file1 [file2] ...
*/

char digit[] = "0123456789ABCDEF";
char buf[512];

/* BB */
char *index();

main(argc, argv)
int argc;
char **argv;
{
	register int infil;
	register unsigned tot;
	register int j, i, k;
	register int c, d;
	char str[41];
	register char *cp;
	register unsigned offset;

	if (argc < 2) {
		puts("usage: od [+n[.]] file1 [file2] ...\n");
		exit(1);
	}
	offset = 0;
	while (--argc) {
		tot = 0;
		++argv;
		if (**argv == '+') {
			cp = *argv + 1;
			if (cp[strlen(cp)-1] == '.')
				offset = atoi(cp);
			else
				offset = atoh(cp);
			offset &= ~7;
			continue;
		}
		if ((infil = open(*argv, 0)) < 0) {
			puts("Can't open file ");
			puts(*argv);
			puts("\n");
			continue;
		}
		lseek(infil, offset, 0, 0);
		tot = offset;
		for (;;) {
			i = read(infil, buf, 8);
			if (i == 0)
				break;
			strcpy(str, "                                       \n");
			htoa(str, tot);
			for (k=6,j=0;j<i;++j) {
				c = buf[j]&0x0f;
				d = (buf[j] >> 4)&0x0f;
				str[k++] = digit[d];
				str[k++] = digit[c];
				++k;
			}
			for (k=31,j=0;j<i;j++)
				if (buf[j] >= ' ' && buf[j] < 0x7f)
					str[k++] = buf[j];
				else
					str[k++] = '.';
			puts(str);
			tot += i;
		}
		close(infil);
	}
}

char hx[] = "0123456789ABCDEF";

atoh(cp)
register char *cp;
{
	register unsigned val = 0;
	register int c;

	while (c = index(hx, toupper(*cp++)))
		val = ((val * 16) + (c - hx);
	return(val);
}

htoa(cp, val)
register char *cp;
register unsigned val;
{
	register char *str;

	str = cp + 5;
	while (str > cp) {
		*--str = hx[val&0x0f];
		val >>= 4;
	}
}

puts(str)
register char *str;
{
#ifdef CPM
	while (*str) {
		if (*str == '\n')
			write(1, "\r", 1);
		write(1, str++, 1);
	}
#else
	write(1, str, strlen(str));
#endif
}
