/*	Copyright (C) 1983 by Manx Software Systems, Inc.	*/

#include	"io.h"
#include	"errno.h"

_get_dev(name, fp)
char *name;
struct fil_tab *fp;
{
	int i, c;
	char *cp;

	if (_parse(name) < 0 || _name[2] == 0)
		return(-1);
	for (i=1;i<=10;++i) {
		if (c = _find_dev(i)) {
			if (c == -1)
				break;
			fp->type = 0;
			fp->dev = i;
			return(i);
		}
	}
	cp = _name + strlen(_name);
	*cp++ = ',';
	*cp++ = _type;
	if (_type == 'L') {
		*cp++ = ',';
		*cp++ = REALREC;
	}
	*cp++ = 0;
	fp->type = _type;
	fp->dev = _device;
	fp->chan = _chan;
	return(_device);
}

_parse(name)
register char *name;
{
	register char *cp;

	errno = 0;
	_type = 'P';
	_chan = 0xff;
	if (*name == 0)
		return(-1);
	_unit = 0;
	_device = 8;
	cp = _name;
	if (name[1] == ':') {
		*cp++ = *name++;
		*cp++ = *name++;
	}
	else {
		*cp++ = '0';
		*cp++ = ':';
	}
	while (*name && *name != ',')
		*cp++ = toupper(*name++);
	*cp = 0;
	while (*name == ',') {
		switch (toupper(*++name)) {
		case 'P':
		case 'S':
		case 'U':
		case 'L':
			_type = toupper(*name++);
			break;
		case 'D':
			_device = 0;
			while (isdigit(*++name))
				_device = _device * 10 + *name - '0';
			break;
		case 'C':
			_chan = 0;
			while (isdigit(*++name))
				_chan = _chan * 10 + *name - '0';
			break;
		default:
			goto error;
		}
	}
	if (*name) {
error:
		errno = E_PARSE;
		return(-1);
	}

	_unit = _name[0] - '0';
	return(0);
}

_find_dev(dev)
int dev;
{
	char *dp;
	extern int _devtab();

	dp = ((struct device *)_devtab) + (dev-1);
	if (*dp == 0)
		return(-1);
	if (strcmp(_name+2, dp) == 0)
		return(dev);
	return(0);
}

